



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【LeetCode】Sum of Two Integers</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【LeetCode】Sum of Two Integers</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-15 18:34:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>问题描述：</p>
<p>Calculate the sum of two integers <em>a</em> and <em>b</em>, but you are <strong>not allowed</strong> to use the operator <code>+</code> and <code>-</code>.</p>
<p><strong>Example:</strong><br /> Given <em>a</em> = 1 and <em>b</em> = 2, return 3.</p>
<p>问题分析：</p>
<p>首先我们可以分析人们是如何做十进制的加法的，比如是如何得出5+17=22这个结果的。实际上，我们可以分成三步的：第一步只做各位相加不进位，此时相加的结果是12（个位数5和7相加不要进位是2，十位数0和1相加结果是1）；第二步做进位，5+7中有进位，进位的值是10；第三步把前面两个结果加起来，12+10的结果是22，刚好5+17=22。<br />&nbsp;&nbsp;&nbsp;&nbsp;前面我们就在想，求两数之和四则运算都不能用，那还能用什么啊？对呀，还能用什么呢？对数字做运算，除了四则运算之外，也就只剩下位运算了。位运算是针对二进制的，我们也就以二进制再来分析一下前面的三步走策略对二进制是不是也管用。<br />&nbsp;&nbsp;&nbsp;&nbsp;5的二进制是101，17的二进制10001。还是试着把计算分成三步：第一步各位相加但不计进位，得到的结果是10100（最后一位两个数都是1，相加的结果是二进制的10。这一步不计进位，因此结果仍然是0）；第二步记下进位。在这个例子中只在最后一位相加时产生一个进位，结果是二进制的10；第三步把前两步的结果相加，得到的结果是10110，正好是22。由此可见三步走的策略对二进制也是管用的。<br />&nbsp;&nbsp;&nbsp;&nbsp;接下来我们试着把二进制上的加法用位运算来替代。第一步不考虑进位，对每一位相加。0加0与 1加1的结果都0，0加1与1加0的结果都是1。我们可以注意到，这和异或的结果是一样的。对异或而言，0和0、1和1异或的结果是0，而0和1、1和0的异或结果是1。接着考虑第二步进位，对0加0、0加1、1加0而言，都不会产生进位，只有1加1时，会向前产生一个进位。此时我们可以想象成是两个数先做位与运算，然后再向左移动一位。只有两个数都是1的时候，位与得到的结果是1，其余都是0。第三步把前两个步骤的结果相加。如果我们定义一个函数，第三步就相当于输入前两步骤的结果来递归调用自己。</p>
<p>问题求解：</p>
<div>
<pre class="prettyprint linenums">int getSum(int a, int b) {<br />
       if(b == 0){<br />
           return a;<br />
       }<br />
       int num1 = a ^ b;<br />
       int num2 = (a &amp; b)&lt;&lt;1;<br />
       return getSum(num1, num2);<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4953wjv8.html">虚拟机VMware与主机共享文件介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlxm3eq.html">【代码笔记】iOS-点击加号增加书架，点击减号减少书架</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnzekgq.html">Linux命令行与图形界面切换方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnr7139.html">dojo使用疑难杂症集锦</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv5g6xq.html">Walkthrough&colon; Arranging Controls on Windows Forms Using Snaplines</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv1x51q.html">Viewpager图片自动轮播，网络图片加载，图片自动刷新</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w53wlq.html">《黄聪&colon;手机移动站SEO优化教程》1、为什么要做手机移动端网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdw5l78.html">文件I&sol;O（不带缓冲）之close函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mek5jrq.html">Vue&period;js安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z6pgj9.html">Progressive Web Apps入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zjkwj9.html">&lpar;笔记&rpar;：组合and继承之访问限制&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1x57dq.html">thinkphp5自动完成</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg2jg48.html">PLSQL 登录出现 ora12638 credential retrieval failed</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y5l2w8.html">unet</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m22746q.html">机器学习中数据清洗&amp;amp&semi;预处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rw6468.html">Swagger相关配置记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j13e7w9.html">基于spec互评Alpha版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g5x0zq.html">POJ 2410</a>
		</li>
						<li><a href="https://www.batexi.com/a/qver7j19.html">JQUERY框架的优点与面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm46ol9.html">流形学习 &lpar;Manifold Learning&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/oqv65e18.html">苹果手机 微信调用百度地图Javascript API 频繁闪退问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlgmdk9.html">Unity-WIKI 之 AllocationStats&lpar;内存分配&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4rz2j8.html">Android签名机制：生成keystore、签名、查看签名信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/390zmx3q.html">&lbrack;Android Studio&rsqb; Android studio 多渠道打包&lpar;超简洁版&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdnwx09.html">通过Nethogs查看服务器网卡流量情况</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96x3549.html">POJ 3974&Tab;Palindrome</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw1ogz8.html">系统广播 android&period;intent&period;action&period;KILL&lowbar;BACKGROUND&lowbar;SERVICE</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxpe5z9.html">Python快速教程 尾声&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/390z4moq.html">JavaScript事件详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn74yk8.html">Andriod Studio Clear Project或Rebuild Project出错</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
